unit ztNew;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, FileCtrl, Buttons, BrowseFolder, ZLib;

type
  Tztfrm_Create = class(TForm)
    SaveDialog: TSaveDialog;
    com: TListBox;
    off: TListBox;
    nor: TListBox;
    PageControl: TPageControl;
    tabArchiv: TTabSheet;
    Label1: TLabel;
    edName: TEdit;
    Label2: TLabel;
    lbDir: TLabel;
    SpeedButton1: TSpeedButton;
    tabFiles: TTabSheet;
    Folders: TDirectoryListBox;
    edMaske: TEdit;
    lbFolder: TLabel;
    Drives: TDriveComboBox;
    Files: TFileListBox;
    Label6: TLabel;
    btAdd: TSpeedButton;
    btDelete: TSpeedButton;
    FileList: TListBox;
    Label3: TLabel;
    Label7: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    BrowseFolder: TBrowseFolder;
    tabCreate: TTabSheet;
    btCreate: TSpeedButton;
    CallBack: TListBox;
    Label5: TLabel;
    ProgressBar: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure btAddClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure edMaskeKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btCreateClick(Sender: TObject);
  private
    TmpDir    : String;
    fCount    : Integer;
    fSizeVor  : Longint;
    fSizeNach : Longint;
    procedure Status(Sender: TObject);
  public
  end;

var
  ztfrm_Create: Tztfrm_Create;

implementation

uses cmpTypes;

{$R *.DFM}

    function GetEnvStr(EnvVar : String) : String;
    var
       PVar : Array[0..254] of Char;
       Buf  : PChar;
    begin
         GetMem(Buf, 255);
         StrPCopy(PVar, EnvVar);
         GetEnvironmentVariable(PVar, Buf, 255);
         Result := StrPas(Buf);
         FreeMem(Buf, 255);
    end;

    procedure Tztfrm_Create.Status(Sender: TObject);
    begin
         ProgressBar.Position := TCustomZLibStream(Sender).Position;
    end;

procedure Tztfrm_Create.FormCreate(Sender: TObject);
begin
     SaveDialog.InitialDir := ExtractFileDir(Application.ExeName);
     PageControl.ActivePage := tabArchiv;
     // Name
     if SaveDialog.Execute then
     begin
          edName.Text := ExtractFileName(SaveDialog.Filename);
          lbDir.Caption := ExtractFileDir(SaveDialog.Filename);
          Folders.Directory := ExtractFileDir(SaveDialog.Filename);
     end else
     begin
          edName.Text := 'unbekannt';
          lbDir.Caption := ExtractFileDir(Application.ExeName);
          Folders.Directory := ExtractFileDir(Application.ExeName);
     end;
     // Temp
     TmpDir := GetEnvStr('TEMP');
     if copy(TmpDir, Length(TmpDir), 1) <> '\' then
        TmpDir := TmpDir + '\';
end;


procedure Tztfrm_Create.btAddClick(Sender: TObject);
var
   I : Integer;
   P : String;
begin
     for i := 0 to Files.Items.Count - 1 do
     begin
          if Files.Selected[i] then
          begin
               P := lowercase(lbFolder.caption);
               if copy(P, length(P), 1) <> '\' then P := P + '\';
               FileList.Items.Add(P + lowercase(Files.Items[i]));
          end;
     end;
end;

procedure Tztfrm_Create.btDeleteClick(Sender: TObject);
begin
     if FileList.ItemIndex >= 0 then
        FileList.Items.Delete(FileList.ItemIndex);
end;

procedure Tztfrm_Create.SpeedButton1Click(Sender: TObject);
begin
     if BrowseFolder.Execute then
        lbDir.Caption := BrowseFolder.Directory;
end;

procedure Tztfrm_Create.edMaskeKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if Key = 13 then
        Files.Mask := edMaske.Text;
end;

procedure Tztfrm_Create.btCreateClick(Sender: TObject);
var
   ZSource    : TFileStream;
   ZDest      : TFileStream;
   ZHeader    : TZHeader;
   ZTable     : TZTable;
   ZTableData : TZTableData;
   ZStream    : TCustomZLibStream;
   InFile     : TStream;
   OutFile    : TStream;

   i          : Integer;
   offTemp    : Longint;
   Path       : String;
   sTmp       : String;
begin
     Path := lbDir.Caption;
     if copy(Path, length(Path), 1) <> '\' then
        Path := Path + '\';
     Path := Path + edName.Text;
     if Pos('Z', UpperCase(ExtractFileExt(Path))) = 0 then
        Path := Path + '.z';

     if FileExists(Path) then
     begin
          CallBack.Items.Add('Lsche altes Archiv ' + Path);
          DeleteFile(Path);
     end;

     CallBack.Items.Clear;
     CallBack.Items.Add('ZLib Version ' + zlib_Version);
     CallBack.Items.Add('Erstelle Archiv ' + Path);

     ZDest := TFileStream.Create(Path, fmCreate);

     ZHeader.ID[0] := 'Z';
     ZHeader.ID[1] := 'L';
     ZHeader.ID[2] := 'i';
     ZHeader.ID[3] := 'b';
     ZHeader.TableOffSet := 0;

     ZDest.WriteBuffer(ZHeader, sizeof(ZHeader));

     fCount := 0;
     fSizeVor := 0;
     fSizeNach := 0;

     for i := 0 to FileList.Items.Count - 1 do
     begin
          // offset sichern
          off.Items.Add(IntToStr(ZDest.Position));

          // komprimieren in Temp-Datei
          CallBack.Items.Add('Komprimiere ' + ExtractFileName(FileList.Items[i]));
          Application.ProcessMessages;

          InFile := TFileStream.Create(FileList.Items[i], fmOpenRead);
          nor.Items.Add(IntToStr(InFile.Size));
          ProgressBar.Max := InFile.Size;
          try
             sTmp := TmpDir + ExtractFileName(FileList.Items[i]);
             OutFile := TFileStream.Create(TmpDir + ExtractFileName(sTmp), fmCreate);
             try
                ZStream := TCompressionStream.Create(clMax, OutFile);
                try
                   TCompressionStream(ZStream).OnProgress := Status;
                   ZStream.CopyFrom(InFile, 0);
                finally
                       ZStream.Free;
                end;

             finally
                    OutFile.Free;
             end;
          finally
                 InFile.Free;
          end;

          // in archiv schreiben
          CallBack.Items.Add('Addiere ' + ExtractFileName(FileList.Items[i]));
          Application.ProcessMessages;

          ZSource := TFileStream.Create(TmpDir + ExtractFileName(sTmp), fmOpenRead);
          com.Items.Add(IntToStr(ZSource.Size));
          ZDest.CopyFrom(ZSource, 0);
          ZSource.Free;

          // Temp Datei lschen
          DeleteFile(TmpDir + ExtractFileName(sTmp));
     end;

     fCount := FileList.Items.Count;
     for i := 0 to nor.items.count - 1 do
         fSizeVor := fSizeVor + strtoint(nor.items[i]);
     for i := 0 to com.items.count - 1 do
         fSizeNach := fSizeNach + strtoint(com.items[i]);

     offTemp := ZDest.Position;

     ZTable.Count := fCount;
     ZDest.WriteBuffer(ZTable, sizeof(ZTable));

     for i := 1 to fCount do
     begin
          sTmp := TmpDir + ExtractFileName(FileList.Items[i - 1]);
          ZTableData.FileName := ExtractFileName(sTmp);
          ZTableData.Offset := strtoint(off.Items[i - 1]);
          ZTableData.Size := strtoint(com.Items[i - 1]);
          ZTableData.CRC := strtoint(nor.Items[i - 1]);

          ZDest.WriteBuffer(ZTableData, sizeof(tZTableData));
     end;

     ZDest.Seek(0, soFromBeginning);
     ZHeader.TableOffset := offTemp;
     ZDest.WriteBuffer(ZHeader, sizeof(ZHeader));

     ZDest.Destroy;
     ShowMessage(
       'Z Archiv erzeugt!'#13 +
       format('Dateien: %d'#13 + 'Gre: %d'#13 + 'Komprimiert: %d',
         [fCount, fSizeVor, fSizeNach]
       )
     );

     ModalResult := mrOk;
end;

end.
